##
##  autocannon.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2022 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package version
%define       V_autocannon      7.9.0
%define       V_autocannon_snap 20220504

#   package information
Name:         autocannon
Summary:      HTTP Load Generator
URL:          https://github.com/mcollina/autocannon
Vendor:       Matteo Collina
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Networking
License:      MIT
Version:      %{V_autocannon}
Release:      20220504

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/autocannon/autocannon-%{V_autocannon}-%{V_autocannon_snap}.tar.gz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, node, node-openpkg
PreReq:       OpenPKG, openpkg >= 20160101, node

%description
    Autocannon is a HTTP/1.1 benchmarking tool with support for HTTP
    pipelining and HTTPS.

%track
    prog autocannon = {
        version   = %{version}
        url       = https://github.com/mcollina/autocannon/releases
        regex     = v(\d+\.\d+\.\d+)\.tar\.gz
    }

%prep
    %setup -q -c

%build
    #   remove more unneccessary files
    #   %{l_prefix}/bin/node-openpkg squeeze

%install
    #   create installation directories
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin \
        $RPM_BUILD_ROOT%{l_prefix}/lib/autocannon

    #   install program files
    %{l_prefix}/bin/node-openpkg install \
        %{l_prefix}/lib/autocannon/

    #   provide wrapper
    ( echo "#!/bin/sh"
      echo "NODE_PATH=%{l_prefix}/lib/autocannon"
      echo "export NODE_PATH"
      echo "exec %{l_prefix}/bin/node %{l_prefix}/lib/autocannon/autocannon/autocannon.js \${1+\"\$@\"}"
    ) >autocannon
    %{l_shtool} install -c -m 755 %{l_value -s -a} \
        autocannon $RPM_BUILD_ROOT%{l_prefix}/bin/autocannon

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

